library(shiny)

plus1 = "<font size=\"+1\">"

shinyServer(function(input, output, session) {
       
  getxy<-reactive({
    m <- 6
    n <- 20
    isolate({
        x <- sort(rep(1:m,n))
        y <- isolate(runif(1,-10,10)+runif(1,-5,5)*x+rnorm(m*n,0,2))
        ybar <- tapply(y,x,mean)
        A <- matrix("black",m*n,m)
        for(k in 1:m) 
             A[((k-1)*n+1):(k*n),k]<-"red"
        return(list(cbind(x,y),ybar,A))
      })
  })          
          
  output$plot2 <- renderPlot({
      m <- 6
      n <- 20
      x <- getxy()[[1]][,1]
      y <- getxy()[[1]][,2]
      ybar <- getxy()[[2]]
      cols <- getxy()[[3]]
      if(input$step==0) {
          plot(x,y, xlab = "x", ylab = "y")
          return(NULL)
      }              
      for(i in 1:input$step) {
          plot(x,y, xlab = "x", ylab = "y", type = "n")
          if(i%%2==1) 
               points(x,y,col=cols[,min(6,(i+1)/2)])
          else {
               points(x,y)
               text(1:min(6,(i+1)/2),ybar[1:min(6,(i+1)/2)],"X",col="red",cex=2)
          }    
          if(input$step==14) abline(lm(y~x),lwd=2,col="red")            
      }    

  })
       
   output$appinfo <- renderText({ 
      HTML("<br>&nbsp;<br>&nbsp;<br>&nbsp;<br>
      <a target=\"_blank\" href=\"http://academic.uprm.edu/wrolke/myapps1.htm#lsr1\"><h4>What to do</h4></a><br>
      <h6>Written by: Dr. Wolfgang Rolke<br>Created: 2/8/2015</h6>")
      
  })     
     output$explainText <- renderText({ 
         "<h5>Run the movie to see and illustration of the meaning of the least squares regression line as the 
         mean of the responses for fixed x values</h5>" 
     })

})

